summaryrefslogtreecommitdiffstats
path: root/sc3-plugins
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2020-06-09 12:43:00 +0000
committer Eric Hameleers <alien@slackware.com>2020-06-09 12:43:00 +0000
commit9475e9247f6b634e109b8fdc09b7b7b03bc26dac (patch)
tree3d557d46241fbdc5d2f733087181c83aabe796b8 /sc3-plugins
parentd1f90ca3dfb5664d494daa122036f4b75d9401f2 (diff)
downloadasb-9475e9247f6b634e109b8fdc09b7b7b03bc26dac.tar.gz
asb-9475e9247f6b634e109b8fdc09b7b7b03bc26dac.tar.xz
Initial revision
Diffstat (limited to 'sc3-plugins')
-rw-r--r--sc3-plugins/build/patches/sc3-plugins_fix_supernova_check.patch67
-rwxr-xr-xsc3-plugins/build/sc3-plugins.SlackBuild217
-rw-r--r--sc3-plugins/build/slack-desc19
-rw-r--r--sc3-plugins/build/slack-required2
4 files changed, 305 insertions, 0 deletions
diff --git a/sc3-plugins/build/patches/sc3-plugins_fix_supernova_check.patch b/sc3-plugins/build/patches/sc3-plugins_fix_supernova_check.patch
new file mode 100644
index 00000000..e110f4a0
--- /dev/null
+++ b/sc3-plugins/build/patches/sc3-plugins_fix_supernova_check.patch
@@ -0,0 +1,67 @@
+From b06bc6e846734d5746408861fd774327f28372f4 Mon Sep 17 00:00:00 2001
+From: David Runge <dave@sleepmap.de>
+Date: Thu, 29 Nov 2018 20:41:51 -0600
+Subject: [PATCH] CMake: Fix wrong check for SUPERNOVA
+
+Fixes #185
+
+so default builds won't fail if SC sources are not around during build time
+---
+ CMakeLists.txt | 27 ++++++++++++++++++++++-----
+ 1 file changed, 22 insertions(+), 5 deletions(-)
+
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index edd6b8cf3..b737d30be 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -2,19 +2,36 @@ cmake_minimum_required (VERSION 2.8)
+ set(SUPERNOVA_CMAKE_MINVERSION 3.1)
+ project (sc3-plugins)
+
++set(NOVA_SIMD_MISSING_ERROR "The nova-simd source code is missing in \
++${CMAKE_CURRENT_SOURCE_DIR}/external_libraries/nova-simd.\n This probably \
++means you forgot to clone submodules.\n To fix this, run `git submodule \
++update --init` from the root of the sc3-plugins repository")
++
+ if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/external_libraries/nova-simd/simd_memory.hpp)
+- message(FATAL_ERROR "The nova-simd submodule is missing. This probably means you forgot to clone submodules. To fix this, run `git submodule update --init` from the root folder of sc3-plugins repository")
++ message(FATAL_ERROR "${NOVA_SIMD_MISSING_ERROR}")
+ endif()
+
++set(STK_MISSING_ERROR "The stk source code is missing in \
++${CMAKE_CURRENT_SOURCE_DIR}/external_libraries/stk.\n This probably means you \
++forgot to clone submodules.\n To fix this, run `git submodule update --init` \
++from the root of the sc3-plugins repository")
++
+ if (NOT SYSTEM_STK)
+ if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/external_libraries/stk/include/Stk.h)
+- message(FATAL_ERROR "The stk submodule is missing. This probably means you forgot to clone submodules. To fix this, run `git submodule update --init` from the root folder of the sc3-plugins repository")
++ message(FATAL_ERROR ${STK_MISSING_ERROR})
+ endif()
+ endif()
+
+-if (SUPERNOVA)
++set(NOVA_TT_MISSING_ERROR "The nova-tt source code is missing in \
++${SC_PATH}/external_libraries/nova-tt.\n Make sure to point to a valid version \
++of SuperCollider's source code (with the help of the SC_PATH variable).\n It's \
++easiest to use a release tarball of SuperCollider.\n If you use a git clone, \
++make sure you have all submodules by running `git submodule update --init \
++--recursive` in the root of SuperCollider's source code repository.")
++
++if (NOVA_DISK_IO)
+ if (NOT EXISTS ${SC_PATH}/external_libraries/nova-tt/CMakeLists.txt)
+- message(FATAL_ERROR "The nova-tt submodule in the SuperCollider repository is missing (required for SuperNova plugins). This probably means you forgot to clone submodules. To fix this, run `git submodule update --init` from the root folder of the SuperCollider repository")
++ message(FATAL_ERROR ${NOVA_TT_MISSING_ERROR})
+ endif()
+ endif()
+
+@@ -55,7 +72,7 @@ option(CPP11 "Build with c++11." ON)
+ option(NATIVE "Optimize for this specific machine." OFF)
+ option(SYSTEM_STK "Use STK libraries from system" OFF)
+ option(HOA_UGENS "Build with HOAUGens (Higher-order Ambisonics)" ON)
+-option(NOVA_DISK_IO "Build with Nova's DiskIO UGens. Requires boost source tree, break warranty & eats your children." OFF)
++option(NOVA_DISK_IO "Build with Nova's DiskIO UGens (experimental). Requires SuperCollider source code." OFF)
+
+ if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
+ set(CMAKE_COMPILER_IS_CLANG 1)
+
diff --git a/sc3-plugins/build/sc3-plugins.SlackBuild b/sc3-plugins/build/sc3-plugins.SlackBuild
new file mode 100755
index 00000000..f7aa846d
--- /dev/null
+++ b/sc3-plugins/build/sc3-plugins.SlackBuild
@@ -0,0 +1,217 @@
+#!/bin/sh
+# $Id$
+# Copyright 2020 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: sc3-plugins
+# Descr: Extension plugins for the SuperCollider3 audio synthesis
+# URL: https://supercollider.github.io/sc3-plugins/
+# Build needs:
+# Needs: supercollider
+# Changelog:
+# 3.10.0-1: 09/Jun/2020 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh sc3-plugins.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=sc3-plugins
+VERSION=${VERSION:-3.10.0}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
+TAG=${TAG:-alien}
+
+DOCS="DEVELOPING.md README.md TODO"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}-Source.tar.bz2"
+SRCURL="https://github.com/supercollider/${PRGNAM}/releases/download/Version-${VERSION}/${PRGNAM}-${VERSION}-Source.tar.bz2"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}-Source
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+# Fix a check which assumes the supercollider sources are present:
+cat $SRCDIR/patches/sc3-plugins_fix_supernova_check.patch \
+ | patch -p1 --verbose 2>&1 | tee $OUTPUT/patch-$PRGNAM.log
+
+# Fix libdir on x86_64:
+sed -e "s,lib/,lib${LIBDIRSUFFIX}/,g" \
+ -i $(find . -name CMakeLists.txt -print0 |xargs -0 grep -l \"lib/)
+
+echo Building ...
+mkdir -p build-${PRGNAM}
+cd build-${PRGNAM}
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DSYSCONF_INSTALL_DIR=/etc \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DSC_PATH=/usr/include/SuperCollider/ \
+ -DSYSTEM_STK=OFF \
+ -DSUPERNOVA=ON \
+ ..
+ make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+ make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+cd -
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/sc3-plugins/build/slack-desc b/sc3-plugins/build/slack-desc
new file mode 100644
index 00000000..6aee2f66
--- /dev/null
+++ b/sc3-plugins/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+sc3-plugins: sc3-plugins (Extension plugins for the SuperCollider3 audio synthesis)
+sc3-plugins:
+sc3-plugins: A community collection of unit generator plugins for SuperCollider,
+sc3-plugins: extending the functionality of SuperCollider by additional UGens
+sc3-plugins: that run on scsynth, the SuperCollider audio synthesis server.
+sc3-plugins: Please note that the UGens in this repository are, on average,
+sc3-plugins: less stable/well-maintained than the core collection.
+sc3-plugins: Use at your own risk!
+sc3-plugins:
+sc3-plugins: sc3-plugins home: https://supercollider.github.io/sc3-plugins/
+sc3-plugins:
diff --git a/sc3-plugins/build/slack-required b/sc3-plugins/build/slack-required
new file mode 100644
index 00000000..0a0cb414
--- /dev/null
+++ b/sc3-plugins/build/slack-required
@@ -0,0 +1,2 @@
+supercollider
+